Attribute VB_Name = "mod_ctSSLayer"
' Copyright (C) 2002-2008 Jan Vorel
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

' If you have any questions, suggestions or bug reports about this product,
' contact me: info@ctuser.net; Do not contact me about general B.A.S.I.C.
' language or A.P.I. issues

Option Explicit
Option Base 0

Public Type QPSongInfoStruct
  FormatOK As Long ' Boolean
  Format_Frequency As Long
  Format_BitRate As Long
  Format_Channels As Long
  Format_VBR As Long ' Boolean
  Format_QualityMulti As Single
  TagOK As Long 'Boolean
  Tag_Year As Long
  Tag_TrackID As Long
  Tag_Artist As String
  Tag_Title As String
  Tag_Album As String
  IR_Name As String
  IR_URL As String
  End Type

'Private Type ShortType
'  Tag_Artist As Long
'  Tag_Title As Long
'  Tag_Album As Long
'  End Type

Private Const LayerVersionID As Long = &H10000690
Private hModul As Long
Private ctSSLayer_CanUseItemInt As Long
Private ctSSLayer_GetDeviceNameInt As Long
Private ctSSLayer_GetDeviceSSLIDInt As Long
Private ctSSLayer_GetInfoStringInt As Long
'Private ctSSLayer_GetStreamNetStatusInt As Long
Private ctSSLayer_GetPositionInt As Long
Private ctSSLayer_GetSpectrumInt As Long
Private ctSSLayer_LoadSongInt As Long
Private ctSSLayer_LoadSongFinishedInt As Long
Private ctSSLayer_LoadSongAbortInt As Long
Private ctSSLayer_LoadSongPlayInt As Long
Private ctSSLayer_MusicGetPatternInt As Long
Private ctSSLayer_MusicGetPatternsInt As Long
Private ctSSLayer_MusicHasFinishedInt As Long
Private ctSSLayer_MusicTimeInt As Long
Private ctSSLayer_ReadSongInfoInt As Long
Private ctSSLayer_SeekSongInt As Long
Private ctSSLayer_SetPauseInt As Long
Private ctSSLayer_SetVolumeInt As Long
Private ctSSLayer_SongLengthInt As Long
Private ctSSLayer_UnloadSongInt As Long

'private h

Public Function ctSSLayer_LoadVB(ParamArray CustomDLLFilenames()) As Long
  Dim xLong1 As Long
  '1=ok/versionid, -1=no dll, 0=incompatible
  
  For xLong1 = 0& To UBound(CustomDLLFilenames())
    hModul = LoadLibrary(CStr(CustomDLLFilenames(xLong1)))
    If Not hModul = 0& Then Exit For
    Next
  
  If hModul = 0& Then
    ctSSLayer_LoadVB = -1&
    Else
    xLong1 = GetProcAddress(hModul, "ctSSLayer_Version")
    If xLong1 = 0& Then
      Call FreeLibrary(hModul)
      ctSSLayer_LoadVB = 0&
      Else
      ctSSLayer_LoadVB = CallFunction_Fast(xLong1, LayerVersionID)
      If ctSSLayer_LoadVB = 0& Then
        Call FreeLibrary(hModul)
        Else
        ctSSLayer_CanUseItemInt = GetProcAddress(hModul, "ctSSLayer_CanUseItem")
        If IsUnicode Then
          ctSSLayer_GetDeviceNameInt = GetProcAddress(hModul, "ctSSLayer_GetDeviceNameW")
          ctSSLayer_GetDeviceSSLIDInt = GetProcAddress(hModul, "ctSSLayer_GetDeviceSSLIDW")
          ctSSLayer_GetInfoStringInt = GetProcAddress(hModul, "ctSSLayer_GetInfoStringW")
          ctSSLayer_LoadSongInt = GetProcAddress(hModul, "ctSSLayer_LoadSongW")
          ctSSLayer_ReadSongInfoInt = GetProcAddress(hModul, "ctSSLayer_ReadSongInfoW")
          Else
          ctSSLayer_GetDeviceNameInt = GetProcAddress(hModul, "ctSSLayer_GetDeviceNameA")
          ctSSLayer_GetDeviceSSLIDInt = GetProcAddress(hModul, "ctSSLayer_GetDeviceSSLIDA")
          ctSSLayer_GetInfoStringInt = GetProcAddress(hModul, "ctSSLayer_GetInfoStringA")
          ctSSLayer_LoadSongInt = GetProcAddress(hModul, "ctSSLayer_LoadSongA")
          ctSSLayer_ReadSongInfoInt = GetProcAddress(hModul, "ctSSLayer_ReadSongInfoA")
          End If
        ctSSLayer_GetPositionInt = GetProcAddress(hModul, "ctSSLayer_GetPosition")
        ctSSLayer_GetSpectrumInt = GetProcAddress(hModul, "ctSSLayer_GetSpectrum")
        ctSSLayer_LoadSongAbortInt = GetProcAddress(hModul, "ctSSLayer_LoadSongAbort")
        ctSSLayer_LoadSongFinishedInt = GetProcAddress(hModul, "ctSSLayer_LoadSongFinished")
        ctSSLayer_LoadSongPlayInt = GetProcAddress(hModul, "ctSSLayer_LoadSongPlay")
        ctSSLayer_MusicGetPatternInt = GetProcAddress(hModul, "ctSSLayer_MusicGetPattern")
        ctSSLayer_MusicGetPatternsInt = GetProcAddress(hModul, "ctSSLayer_MusicGetPatterns")
        ctSSLayer_MusicHasFinishedInt = GetProcAddress(hModul, "ctSSLayer_MusicHasFinished")
        ctSSLayer_MusicTimeInt = GetProcAddress(hModul, "ctSSLayer_MusicTime")
        ctSSLayer_SeekSongInt = GetProcAddress(hModul, "ctSSLayer_SeekSong")
        ctSSLayer_SetPauseInt = GetProcAddress(hModul, "ctSSLayer_SetPause")
        ctSSLayer_SetVolumeInt = GetProcAddress(hModul, "ctSSLayer_SetVolume")
        ctSSLayer_SongLengthInt = GetProcAddress(hModul, "ctSSLayer_SongLength")
        ctSSLayer_UnloadSongInt = GetProcAddress(hModul, "ctSSLayer_UnloadSong")
        End If
      End If
    End If
  
  End Function

Public Sub ctSSLayer_UnLoadVB()
  If Not hModul = 0& Then
    Call CallFunction_Indirect(hModul, "ctSSLayer_DllRelease")
    FreeLibrary (hModul)
    End If
  End Sub

Public Function ctSSLayer_CanUseItem(ByVal Index As Long) As Long
  ctSSLayer_CanUseItem = CallFunction_Fast(ctSSLayer_CanUseItemInt, Index)
  End Function

Public Sub ctSSLayer_Close(ByVal Fast As Long)
  Call CallFunction_Indirect(hModul, "ctSSLayer_Close", Fast)
  End Sub

Public Function ctSSLayer_GetDeviceFromSSLID(ByVal DeviceSSLID As String) As Long
  Dim xLong1 As Long

  If IsUnicode Then
    ctSSLayer_GetDeviceFromSSLID = CallFunction_Indirect(hModul, "ctSSLayer_GetDeviceFromSSLIDW", StrPtr(DeviceSSLID))
    Else
    xLong1 = LocalAllocFromString(DeviceSSLID)
    If Not xLong1 = 0& Then
      ctSSLayer_GetDeviceFromSSLID = CallFunction_Indirect(hModul, "ctSSLayer_GetDeviceFromSSLIDA", xLong1)
      Call LocalFree(xLong1)
      End If
    End If
  End Function

Public Function ctSSLayer_GetDeviceName(ByVal DeviceID As Long, ByRef Flags As Long) As String
  ctSSLayer_GetDeviceName = PeekS(CallFunction_Fast(ctSSLayer_GetDeviceNameInt, DeviceID, VarPtr(Flags)))
  End Function

Public Function ctSSLayer_GetDeviceSSLID(ByVal DeviceID As Long) As String
  ctSSLayer_GetDeviceSSLID = PeekS(CallFunction_Fast(ctSSLayer_GetDeviceSSLIDInt, DeviceID))
  End Function

Public Function ctSSLayer_GetInfoString(ByVal Index As Long) As String
  ctSSLayer_GetInfoString = PeekS(CallFunction_Fast(ctSSLayer_GetInfoStringInt, Index))
  End Function

'Public Function ctSSLayer_GetStreamNetStatus(ByVal SongPointer As Long, ByRef CurrentBitRate As Long)
'  ctSSLayer_GetStreamNetStatus = CallFunction_Fast(ctSSLayer_GetStreamNetStatusInt, SongPointer, VarPtr(CurrentBitRate))
'  End Function

Public Function ctSSLayer_GetPosition(ByVal SongPointer As Long) As Long
  ctSSLayer_GetPosition = CallFunction_Fast(ctSSLayer_GetPositionInt, SongPointer)
  End Function

Public Sub ctSSLayer_GetSpectrum(ByRef xSingleA1Array As Single, ByVal ArraySize As Long, ByVal SongPointer As Long, ByVal Stereo As Boolean)
  Call CallFunction_Fast(ctSSLayer_GetSpectrumInt, VarPtr(xSingleA1Array), ArraySize, SongPointer, -CLng(Stereo * 3&))
  End Sub

Public Function ctSSLayer_Init(ByVal OutputDeviceID As Long, ByVal hWnd As Long, ByVal UseCDDA As Long, ByVal UseJitterCorrection As Long) As Long
  ctSSLayer_Init = CallFunction_Indirect(hModul, "ctSSLayer_Init", OutputDeviceID, hWnd, UseCDDA, UseJitterCorrection)
  End Function

Public Function ctSSLayer_LoadSong(ByVal Mode As Long, ByVal Filename As String, ByVal Flags As Long) As Long
  Dim xLong1 As Long

  If IsUnicode Then
    ctSSLayer_LoadSong = CallFunction_Fast(ctSSLayer_LoadSongInt, Mode, StrPtr(Filename), Flags)
    Else
    xLong1 = LocalAllocFromString(Filename)
    If Not xLong1 = 0& Then
      ctSSLayer_LoadSong = CallFunction_Fast(ctSSLayer_LoadSongInt, Mode, xLong1, Flags)
      Call LocalFree(xLong1)
      End If
    End If
  End Function

Public Function ctSSLayer_LoadSongFinished(ByVal SongPointer As Long) As Long
  ctSSLayer_LoadSongFinished = CallFunction_Fast(ctSSLayer_LoadSongFinishedInt, SongPointer)
  End Function

Public Sub ctSSLayer_LoadSongAbort(ByVal SongPointer As Long)
  Call CallFunction_Fast(ctSSLayer_LoadSongAbortInt, SongPointer)
  End Sub

Public Function ctSSLayer_LoadSongPlay(ByVal SongPointer As Long, ByVal Volume As Long, ByVal LoopSong As Long, ByVal Panning As Long, ByVal Paused As Long) As Long
  ctSSLayer_LoadSongPlay = CallFunction_Fast(ctSSLayer_LoadSongPlayInt, SongPointer, Volume, LoopSong, Panning, Paused)
  End Function

Public Function ctSSLayer_MusicGetPattern(ByVal SongPointer As Long) As Long
  ctSSLayer_MusicGetPattern = CallFunction_Fast(ctSSLayer_MusicGetPatternInt, SongPointer)
  End Function

Public Function ctSSLayer_MusicGetPatterns(ByVal SongPointer As Long) As Long
  ctSSLayer_MusicGetPatterns = CallFunction_Fast(ctSSLayer_MusicGetPatternsInt, SongPointer)
  End Function

Public Function ctSSLayer_MusicHasFinished(ByVal SongPointer As Long) As Long
  ctSSLayer_MusicHasFinished = CallFunction_Fast(ctSSLayer_MusicHasFinishedInt, SongPointer)
  End Function

Public Function ctSSLayer_MusicTime(ByVal SongPointer As Long) As Long
  ctSSLayer_MusicTime = CallFunction_Fast(ctSSLayer_MusicTimeInt, SongPointer)
  End Function

Public Function ctSSLayer_PreInit(ByVal hWnd As Long) As Long
  ctSSLayer_PreInit = CallFunction_Indirect(hModul, "ctSSLayer_PreInit", hWnd)
  End Function

Public Function ctSSLayer_ReadSongInfo(ByVal SongPointer As Long, xSongInfo As QPSongInfoStruct) As Boolean
  'Dim xType1 As ShortType
  'Dim xByteA1(47) As Byte
  Dim xLongA1(13&) As Long

  ctSSLayer_ReadSongInfo = Not (CallFunction_Fast(ctSSLayer_ReadSongInfoInt, SongPointer, VarPtr(xLongA1(0))) = 0&)
  Call RtlMoveMemory(xSongInfo, ByVal VarPtr(xLongA1(0)), 36&)

  xSongInfo.Tag_Artist = PeekS(xLongA1(9&)) 'xType1.Tag_Artist)
  xSongInfo.Tag_Title = PeekS(xLongA1(10&)) 'xType1.Tag_Title)
  xSongInfo.Tag_Album = PeekS(xLongA1(11&)) 'xType1.Tag_Album)
  xSongInfo.IR_Name = PeekS(xLongA1(12&))
  xSongInfo.IR_URL = PeekS(xLongA1(13&))
  End Function

Public Function ctSSLayer_RefreshDeviceList(ByVal hWnd As Long)
  ctSSLayer_RefreshDeviceList = CallFunction_Indirect(hModul, "ctSSLayer_RefreshDeviceList", hWnd)
  End Function

Public Function ctSSLayer_SeekSong(ByVal SongPointer As Long, ByVal SeekPosition As Long) As Long
  ctSSLayer_SeekSong = CallFunction_Fast(ctSSLayer_SeekSongInt, SongPointer, SeekPosition)
  End Function

Public Sub ctSSLayer_SetEndCallback(ByVal hWnd As Long, ByVal Message As Long, ByVal wParam As Long)
  Call CallFunction_Indirect(hModul, "ctSSLayer_SetEndCallback", hWnd, Message, wParam)
  End Sub

Public Sub ctSSLayer_SetPause(ByVal SongPointer As Long, ByVal Pause As Long)
  Call CallFunction_Fast(ctSSLayer_SetPauseInt, SongPointer, Pause)
  End Sub

Public Sub ctSSLayer_SetSpectrum(ByVal State As Long)
'Debug.Print "SS", State
  Call CallFunction_Indirect(hModul, "ctSSLayer_SetSpectrum", State)
'Debug.Print "ok"
  End Sub

Public Sub ctSSLayer_SetVolume(ByVal SongPointer As Long, ByVal Volume As Long)
  Call CallFunction_Fast(ctSSLayer_SetVolumeInt, SongPointer, Volume)
  End Sub

Public Function ctSSLayer_SongLength(ByVal SongPointer As Long) As Long
  ctSSLayer_SongLength = CallFunction_Fast(ctSSLayer_SongLengthInt, SongPointer)
  End Function

Public Sub ctSSLayer_UnloadSong(ByVal SongPointer As Long)
  Call CallFunction_Fast(ctSSLayer_UnloadSongInt, SongPointer)
  End Sub

Public Sub ctSSLayer_UpdateCDDA(ByVal UseCDDA As Long, ByVal UseJitterCorrection As Long)
  Call CallFunction_Indirect(hModul, "ctSSLayer_UpdateCDDA", UseCDDA, UseJitterCorrection)
  End Sub

Public Sub ctSSLayer_UpdateLooping(ByVal SongPointer As Long, ByVal LoopSong As Long)
  Call CallFunction_Indirect(hModul, "ctSSLayer_UpdateLooping", SongPointer, LoopSong)
  End Sub

Public Sub ctSSLayer_UpdatePanning(ByVal SongPointer As Long, ByVal Panning As Long)
  Call CallFunction_Indirect(hModul, "ctSSLayer_UpdatePanning", SongPointer, Panning)
  End Sub
