EnableExplicit

; Copyright (C) 2002-2007 Jan Vorel
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
; If you have any questions, suggestions or bug reports about this product,
; contact me: info@ctuser.net; Do not contact me about general B.A.S.I.C.
; language or A.P.I. issues
;
; Still some division by zero / GrabError problems with FModEx
;
; Modified 2005 for BASS
; Currently supporting 2.02 / 2.03




Prototype.f ProtoBASS_ChannelBytes2Seconds(Handle.l, Pos.q)
Prototype.q ProtoBASS_ChannelSeconds2Bytes(Handle.l, Pos.f)
Prototype.q ProtoBASS_ChannelGetLength(Handle.l)
Prototype.q ProtoBASS_ChannelGetPosition(Handle.l)
Prototype.l ProtoBASS_ChannelSetPosition(Handle.l, Pos.q)
Prototype.l ProtoBASS_ChannelSetAttributes(Handle.l, frequ.w, Volume.w, Pan.w)


ProcedureDLL AttachProcess(Instance)
  ;OpenConsole()
  Global *BassDLL

  #OutPutListMax = 32
  Global OutPutListCount.l
  Global Dim OutPutList.s(#OutPutListMax)

  Global InfoString.s
  CompilerIf #ctSSLayer_CompiledFeature_NoNeedUnicodeConversion_AtoW = 0
    Global InfoStringW.l ;= AllocateMemory(1024)
    CompilerEndIf
  
  Structure QPSongInfoStruct
    FormatOK.l
    Format_Frequency.l
    Format_BitRate.l
    Format_Channels.l
    Format_VBR.l
    Format_QualityMulti.l
    TagOK.l
    Tag_Year.l
    Tag_TrackID.l
    Tag_Artist.l
    Tag_Title.l
    Tag_Album.l
    EndStructure


  ;CompilerIf #ctSSLayer_CompiledFeature_Spectrum
  ;  #ctSSLayer_SpectrumArrayCountX = #ctSSLayer_SpectrumArrayCount - 1
  ;  CompilerEndIf

  #ctSSLayer_MaxIDs = 16
  #ctSSLayer_MaxIDsX = #ctSSLayer_MaxIDs - 1
  #KeepAliveTime = 1000

  CompilerIf #ctSSLayer_CompiledFeature_ReadTags
    Structure BASS_CHANNELINFO
      freq.l
      chans.l
      flags.l
      ctype.l
      origres.l
      hPlugin.l
      EndStructure
    CompilerEndIf

  Global *BASS_StreamCreateFile
  Global *BASS_ChannelPlay
  Global *BASS_StreamFree
  Global *BASS_ChannelPause
  Global *BASS_ChannelIsActive
  Global *BASS_MusicLoad
  Global *BASS_MusicSetAttribute
  Global *BASS_MusicFree
  Global *BASS_ChannelGetData
  CompilerIf #ctSSLayer_CompiledFeature_ReadTags
    Global *BASS_ChannelGetInfo
    CompilerEndIf
  
  Global xSystem.l

  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Global IsCDing.l
    CompilerEndIf

  #BASS_ACTIVE_STOPPED = 0
  #BASS_ACTIVE_STALLED = 2

  Structure tSong
    Mode.l
    Pointer.l
    ExtraA.l
    Size.l
    CompilerIf #ctSSLayer_CompiledFeature_ReadTags
      Format_QualityMulti.f
      CompilerEndIf
    FileSize.l
    ShouldPlay.l
    EndStructure

  ;Global Dim Song.tSong(#ctSSLayer_MaxIDsX)
  Global xSysPath.s
  Global xNoDirectX.l
  Global VersionID.l
  Global VersionIDEx.l
  
  Global *BASS_MPC
  Global *BASS_MPC_StreamCreateFile
  Global *BASS_WMA
  Global *BASS_WMA_StreamCreateFile
  Global *BASS_AAC
  Global *BASS_AAC_StreamCreateFile  
  ;Global *BASS_MP4_StreamCreateFile
  Global *BASS_AC3
  Global *BASS_AC3_StreamCreateFile
  Global *BASS_APE
  Global *BASS_APE_StreamCreateFile
  Global *BASS_FLAC
  Global *BASS_FLAC_StreamCreateFile
  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Global *BASS_CD
    Global *BASS_CD_StreamCreate
    Global *BASS_CD_GetDriveLetter
    CompilerEndIf

  EndProcedure

XIncludeFile "ctSSLayer_Common01.pb"

Procedure TestForDLL_BASS_Ex(DllFilename.s, *ptrToLibPtr, *ptrToFunctionPtr, FunctionName.s)
  Define.l xLong1
  Define.l xLong2
  
  ;Debug "Ver: " + Hex(VersionIDEx) + " " + Str(VersionIDEx)
  If TestForDll(DllFilename, VersionIDEx, VersionIDEx)
    xLong1 = OpenLibrary(#PB_Any, DllFilename)
    ;Debug "  OpenLibrary (" + DllFilename + "): " + Str(xLong1)
    If xLong1
      xLong2 = GetFunction(xLong1, FunctionName)
      ;Debug "GetFunction: (" + FunctionName + ")" + Str(xLong1)
      If xLong2
        PokeL(*ptrToLibPtr, xLong1)
        PokeL(*ptrToFunctionPtr, xLong2)
        Else
        CloseLibrary(xLong1)
        EndIf
      EndIf
    EndIf
  EndProcedure

Procedure GetPreFuncs()
  Static HasDone.l
  
  If Not HasDone
    HasDone = 1
    TestForDLL_BASS_Ex("bass_mpc.dll", @*BASS_MPC, @*BASS_MPC_StreamCreateFile, "BASS_MPC_StreamCreateFile")
    If TestForDll(xSysPath + "wmasf.dll", 7.0001)
      TestForDLL_BASS_Ex("basswma.dll", @*BASS_WMA, @*BASS_WMA_StreamCreateFile, "BASS_WMA_StreamCreateFile")
      EndIf
    TestForDLL_BASS_Ex("bass_aac.dll", @*BASS_AAC, @*BASS_AAC_StreamCreateFile, "BASS_AAC_StreamCreateFile")
    ;If *BASS_AAC_StreamCreateFile
    ;  *BASS_MP4_StreamCreateFile = GetFunction(*BASS_AAC, "BASS_MP4_StreamCreateFile")
    ;  Else
    ;  TestForDLL_BASS_Ex("bass_aac.dll", @*BASS_AAC, @*BASS_MP4_StreamCreateFile, "BASS_MP4_StreamCreateFile")
    ;  EndIf
    TestForDLL_BASS_Ex("bass_ac3.dll", @*BASS_AC3, @*BASS_AC3_StreamCreateFile, "BASS_AC3_StreamCreateFile")
    TestForDLL_BASS_Ex("bass_ape.dll", @*BASS_APE, @*BASS_APE_StreamCreateFile, "BASS_APE_StreamCreateFile")
    TestForDLL_BASS_Ex("bassflac.dll", @*BASS_FLAC, @*BASS_FLAC_StreamCreateFile, "BASS_FLAC_StreamCreateFile")
    CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      TestForDLL_BASS_Ex("basscd.dll", @*BASS_CD, @*BASS_CD_StreamCreate, "BASS_CD_StreamCreate")
      If *BASS_CD_StreamCreate
        *BASS_CD_GetDriveLetter = GetFunction(*BASS_CD, "BASS_CD_GetDriveLetter")
        If Not *BASS_CD_GetDriveLetter
          CloseLibrary(*BASS_CD)
          *BASS_CD = 0
          *BASS_CD_StreamCreate = 0
          EndIf
        EndIf
      CompilerEndIf
    EndIf
  EndProcedure

Procedure GetFuncs()
  *BASS_StreamCreateFile = GetFunction(*BassDLL, "BASS_StreamCreateFile")
  *BASS_ChannelPlay = GetFunction(*BassDLL, "BASS_ChannelPlay")
  *BASS_StreamFree = GetFunction(*BassDLL, "BASS_StreamFree")
  *BASS_ChannelPause = GetFunction(*BassDLL, "BASS_ChannelPause")
  *BASS_ChannelIsActive = GetFunction(*BassDLL, "BASS_ChannelIsActive")
  *BASS_MusicLoad = GetFunction(*BassDLL, "BASS_MusicLoad")
  *BASS_MusicSetAttribute = GetFunction(*BassDLL, "BASS_MusicSetAttribute")
  *BASS_MusicFree = GetFunction(*BassDLL, "BASS_MusicFree")
  *BASS_ChannelGetData = GetFunction(*BassDLL, "BASS_ChannelGetData")
  CompilerIf #ctSSLayer_CompiledFeature_ReadTags
    *BASS_ChannelGetInfo = GetFunction(*BassDLL, "BASS_ChannelGetInfo")
    CompilerEndIf

  Global BASS_ChannelBytes2Seconds.ProtoBASS_ChannelBytes2Seconds = GetFunction(*BassDLL, "BASS_ChannelBytes2Seconds")
  Global BASS_ChannelSeconds2Bytes.ProtoBASS_ChannelSeconds2Bytes = GetFunction(*BassDLL, "BASS_ChannelSeconds2Bytes")
  Global BASS_ChannelGetLength.ProtoBASS_ChannelGetLength = GetFunction(*BassDLL, "BASS_ChannelGetLength")
  Global BASS_ChannelGetPosition.ProtoBASS_ChannelGetPosition = GetFunction(*BassDLL, "BASS_ChannelGetPosition")
  Global BASS_ChannelSetPosition.ProtoBASS_ChannelSetPosition = GetFunction(*BassDLL, "BASS_ChannelSetPosition")
  Global BASS_ChannelSetAttributes.ProtoBASS_ChannelSetAttributes = GetFunction(*BassDLL, "BASS_ChannelSetAttributes")
  EndProcedure

ProcedureDLL DetachProcess(Instance)
  If *BassDLL
    If xSystem
      ; Calling after plugin unloads gets an error... so some plugins do?
      CallFunction(*BassDLL, "BASS_Free")
      EndIf
    If *BASS_MPC_StreamCreateFile: CloseLibrary(*BASS_MPC): EndIf
    If *BASS_WMA_StreamCreateFile: CloseLibrary(*BASS_WMA): EndIf
    ;If *BASS_AAC_StreamCreateFile Or *BASS_MP4_StreamCreateFile: CloseLibrary(*BASS_AAC): EndIf
    If *BASS_AAC_StreamCreateFile: CloseLibrary(*BASS_AAC): EndIf
    If *BASS_AC3_StreamCreateFile: CloseLibrary(*BASS_AC3): EndIf
    If *BASS_APE_StreamCreateFile: CloseLibrary(*BASS_APE): EndIf
    If *BASS_FLAC_StreamCreateFile: CloseLibrary(*BASS_FLAC): EndIf
    CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      If *BASS_CD_StreamCreate: CloseLibrary(*BASS_CD): EndIf
      CompilerEndIf
    CloseLibrary(*BassDLL)
    EndIf
  ;CloseConsole()
  EndProcedure

ProcedureDLL AttachThread(Instance)
  EndProcedure

ProcedureDLL DetachThread(Instance)
  EndProcedure

ProcedureDLL.l ctSSLayer_CanUseItem(Index.l)
  Define.l ctSSLayer_CanUseItem

  Select Index
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case 0 ; cdda
      ctSSLayer_CanUseItem = 1
    Case 1 ; jitter
      ctSSLayer_CanUseItem = 0
    Case 2 ; runtimecdda/jitter update
      ctSSLayer_CanUseItem = 0
CompilerEndIf
    Case 3 ; checkaccuratestreams
      ctSSLayer_CanUseItem = 2
CompilerIf #ctSSLayer_CompiledFeature_Spectrum
    Case 4 ; UseSpectrum   (disabled / 1=mono / 2=stereo)
      ctSSLayer_CanUseItem = 1
CompilerEndIf
;    Case 5 ' UseGetCDDtracks
;      ctSSLayer_CanUseItem = 0&
    Case 6 ; ModuleTimeHandling:
      ; 1 = Patterns
      ; 2 = Elapsed time (only)
      ; 4 = Real times
      ctSSLayer_CanUseItem = 4
    Case 7 ; maxDeviceCount
      ctSSLayer_CanUseItem = OutPutListCount
;    Case 9 ; MidiXFade
;      ctSSLayer_CanUseItem = 0 ;testing
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case $A ; SupportsCD Or CDDA (0/1)
      If *BASS_CD_StreamCreate
        ctSSLayer_CanUseItem = 1
        EndIf
      ;ctSSLayer_CanUseItem = 1
CompilerEndIf
    Case $C ; KeepAliveTime: leave channel stopped before unloading (buffer!)
      ctSSLayer_CanUseItem = #KeepAliveTime
    Case $D      ;#ctSSLayer_MaxIDs ; for future use, currently fixed
      ctSSLayer_CanUseItem = #ctSSLayer_MaxIDs
CompilerIf #ctSSLayer_CompiledFeature_RefreshDeviceList
    ;Case $E
CompilerEndIf
;CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
;    Case $10
;    Case $11
;    Case $12
;CompilerEndIf

    Case $20 ; ctSSLayer_Useable
      ;    10 = should update
      ;    11 = untested
      ;    12 = new & untested
      ;    13 = hasrestrictions, up/downgrade

      ;  < 20 = ok

      ;    20 (DirectX missing)
      ;    21 (DirectX to old (or missing))
      ;    30 = to old
      ;    31 = incompatible
      ;    32 = to new
      ;    90 = cannot load (generic something missing)
      ;         should have high priority!


      ; +$1000000 = retry (dll not found or can retry)
      Select VersionID
        Case 0, -1
          ctSSLayer_CanUseItem = 90
        Case 20002, 20003
          If xNoDirectX
            ctSSLayer_CanUseItem = 21
            ;Else
            ;ctSSLayer_CanUseItem = $0
            EndIf
        Case 0 To 20001
          ctSSLayer_CanUseItem = 30
        Default
          ctSSLayer_CanUseItem = 32
        EndSelect
    EndSelect
  ProcedureReturn ctSSLayer_CanUseItem
  EndProcedure

ProcedureDLL ctSSLayer_Close(Fast.l)
  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    ;If IsCDing
    ;  EndIf
    CompilerEndIf
  CallFunction(*BassDLL, "BASS_Free")
  xSystem = 0
  EndProcedure

ProcedureDLL.l ctSSLayer_DllRelease()
  If *BassDLL
    CloseLibrary(*BassDLL)
    *BassDLL = 0
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_GetDeviceFromSSLID
  CompilerIf #ctSSLayer_CompiledFeature_GetDeviceFromSSLIDA
  ProcedureDLL.l ctSSLayer_GetDeviceFromSSLIDA(*SSLID)
  CompilerElse
  Procedure.l ctSSLayer_GetDeviceFromSSLIDA(*SSLID)
  CompilerEndIf
    Define.l Result
    Define.s xChar1

    Result = -1
    If *SSLID
      xChar1 = LCase(PeekS(*SSLID))
      If Left(xChar1, 5) = "bass_"
        Result = Val(Mid(xChar1, 6))
        If Result < 0 Or Result >= OutPutListCount
          Result = -1
          EndIf
        EndIf
      EndIf
    ProcedureReturn Result

    CompilerIf #ctSSLayer_CompiledFeature_GetDeviceFromSSLIDA = 1
    EndProcedure
    CompilerElse
    EndProcedure
    CompilerEndIf
  CompilerEndIf
CompilerIf 0
  ProcedureDLL.l ctSSLayer_GetDeviceFromSSLIDW(*SSLID)
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_GetDeviceSSLID
  CompilerIf #ctSSLayer_CompiledFeature_GetDeviceSSLIDA
  ProcedureDLL.l ctSSLayer_GetDeviceSSLIDA(DeviceID.l)
  CompilerElse
  Procedure.l ctSSLayer_GetDeviceSSLIDA(DeviceID.l)
  CompilerEndIf
    
    If DeviceID >= 0 And DeviceID < OutPutListCount
      InfoString = "bass_" + Str(DeviceID)
      ProcedureReturn @InfoString
      EndIf

  CompilerIf #ctSSLayer_CompiledFeature_GetDeviceSSLIDA
    EndProcedure
  CompilerElse
    EndProcedure
  CompilerEndIf
  CompilerEndIf
CompilerIf 0
  ProcedureDLL.l ctSSLayer_GetDeviceSSLIDW(*SSLID)
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_GetDeviceName
  CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameA
  ProcedureDLL.l ctSSLayer_GetDeviceNameA(DeviceID.l, *Flags)
  CompilerElse
  Procedure.l ctSSLayer_GetDeviceNameA(DeviceID.l, *Flags)
  CompilerEndIf
    If DeviceID >= 0 And DeviceID < OutPutListCount
      If *Flags: PokeL(*Flags, $100 + DeviceID): EndIf
      InfoString = OutPutList(DeviceID)
      ProcedureReturn @InfoString
      EndIf
    CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameA
    EndProcedure
    CompilerElse
    EndProcedure
    CompilerEndIf
  CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameW
  ProcedureDLL.l ctSSLayer_GetDeviceNameW(DeviceID, *Flags)
    If ctSSLayer_GetDeviceNameA(DeviceID, *Flags)
      MakeUnicode()
      ProcedureReturn InfoStringW
      Else
      ProcedureReturn 0
      EndIf
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_GetInfoStringA
ProcedureDLL.l ctSSLayer_GetInfoStringA(Index.l)
CompilerElse
Procedure.l ctSSLayer_GetInfoStringA(Index.l)
CompilerEndIf

  Select Index
    Case 0 ; ShortName
      InfoString = "BASS"
    Case 1 ; FullName
      InfoString = "BASS Audio library (by Ian Luck)"
    Case 2 ; DllName
      InfoString = "bass.dll"
;    Case 3 ; Short QPlayer Version byfix
;      InfoString = "bass"
    Case 4 ; Unique dll/versions string
      InfoString = "bass_" + PeekS(ctSSLayer_GetInfoStringA(30))

    Case $10 ; StreamsAll
      InfoString = "ogg;mp1,mp2,mp3;"
      If *BASS_MPC_StreamCreateFile: InfoString + "mpc;": EndIf
      If *BASS_WMA_StreamCreateFile: InfoString + "wma;": EndIf
     ; If *BASS_AAC_StreamCreateFile
     ;   If*BASS_MP4_StreamCreateFile
     ;     InfoString + "aac,mp4;"
      ;    Else
      ;    InfoString + "aac;"
      ;    EndIf
      ;  ElseIf *BASS_MP4_StreamCreateFile
      ;  InfoString + "mp4;"
      ;  EndIf
      If *BASS_AAC_StreamCreateFile: InfoString + "aac;": EndIf
      If *BASS_AC3_StreamCreateFile: InfoString + "ac3;": EndIf
      If *BASS_APE_StreamCreateFile: InfoString + "ape;": EndIf
      If *BASS_FLAC_StreamCreateFile: InfoString + "flac;": EndIf
      InfoString + "wav;"
    Case $11 ; TrackerAllbutMidi
      InfoString = "mod,it,xm,s3m;mtm;mo3;umx;"
    ;Case $12 ; Midi
      ;InfoString = "mid,midi;rmi,sgt;"
    Case $19 ; AllDef
      InfoString = "ogg;mp2,mp3;"
      If *BASS_MPC_StreamCreateFile: InfoString + "mpc;": EndIf


    Case $30
      ;Debug Hex(VersionID & $ffff0000)
      ;Debug Hex((VersionID & $ffff0000) >> 16)
      ;Define xLong1.l
      ;xLong1 = Int (VersionID / 
      InfoString = Str(Int(VersionID / 10000)) + "." + Right("0" + Str(VersionID & $ffff), 2)
    Case $31 ; required dll files; seperate with ;!
      InfoString = "bass.dll;msvcrt.dll"

    Case $40 ; homepage URL
      InfoString = "http://www.un4seen.com"
    Default
      InfoString = ""
      ProcedureReturn 0
    EndSelect
  ProcedureReturn @InfoString
CompilerIf #ctSSLayer_CompiledFeature_GetInfoStringA ; for PB IDE folding feature
  EndProcedure                                       ; for PB IDE folding feature
CompilerElse                                         ; for PB IDE folding feature
  EndProcedure                                       ; for PB IDE folding feature
CompilerEndIf                                        ; for PB IDE folding feature

CompilerIf 0                                         ; for enlisting in current project, real procedure in common file
  ProcedureDLL.l ctSSLayer_GetInfoStringW(Index.l)   ; for enlisting in current project, real procedure in common file
    EndProcedure                                     ; for enlisting in current project, real procedure in common file
  CompilerEndIf                                      ; for enlisting in current project, real procedure in common file

ProcedureDLL.l ctSSLayer_GetPosition(*SongPointer.tSong)
  If *SongPointer\Mode
    Define.l ctSSLayer_GetPosition
    Select CallFunctionFast(*BASS_ChannelIsActive, *SongPointer\Pointer)
      Case #BASS_ACTIVE_STALLED
        ctSSLayer_GetPosition = *SongPointer\Size
      Case #BASS_ACTIVE_STOPPED
        ctSSLayer_GetPosition = 0
      Default
        ;ctSSLayer_GetPosition = CallFunctionFast(*BASS_ChannelGetPosition, *SongPointer\Pointer)
        ;ProcedureReturn (CallFunctionFast(*BASS_ChannelBytes2Seconds, *SongPointer\Pointer, ctSSLayer_GetPosition, 0) * 1000)
        ;ctSSLayer_GetPosition = CallFunctionFast(*BASS_ChannelGetPosition, *SongPointer\Pointer)
        ctSSLayer_GetPosition = (BASS_ChannelBytes2Seconds(*SongPointer\Pointer, BASS_ChannelGetPosition(*SongPointer\Pointer)) * 1000)
      EndSelect
    ProcedureReturn ctSSLayer_GetPosition
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_Spectrum
  ProcedureDLL ctSSLayer_GetSpectrum(*xSingleA1, ArraySize.l, *SongPointer.tSong, Stereo.l)
    Static xLong1.l
    Static xLong2.l
    Static xLong4.l
    Static xSingle1.f
  
    #xWGS_GetWidth = 1024
    #xWGS_GetWidth_ArrayLIDX = #xWGS_GetWidth - 1
    Static Dim xSingleA2.f(#xWGS_GetWidth_ArrayLIDX)
  
    If *SongPointer
      CallFunctionFast(*BASS_ChannelGetData, *SongPointer\Pointer, @xSingleA2(0), $80000002)
      If ArraySize > #xWGS_GetWidth: ArraySize = #xWGS_GetWidth: EndIf
      For xLong1 = 0 To ArraySize - 1
        xLong2 = xLong1 * #xWGS_GetWidth / ArraySize
        xSingle1 = xSingleA2(xLong2)
        For xLong4 = xLong2 + 1 To (xLong1 + 1) * #xWGS_GetWidth / ArraySize - 1
          xSingle1 = MaxF(xSingle1, xSingleA2(xLong4))
          Next
        xSingleA2(xLong1) = xSingle1
        Next
      CopyMemory(@xSingleA2(0), *xSingleA1, ArraySize * 4)
      If Stereo = 3
        CopyMemory(@xSingleA2(ArraySize), *xSingleA1, ArraySize * 4)
        EndIf
      Else
      If Stereo = 3
        RtlZeroMemory_(*xSingleA1, ArraySize * 8)
        Else
        RtlZeroMemory_(*xSingleA1, ArraySize * 4)
        EndIf
      EndIf
    EndProcedure
  CompilerEndIf

ProcedureDLL.l ctSSLayer_Init(OutputDeviceID, hWnd.l, UseCDDA.l, UseJitterCorrection.l)
  If OutputDeviceID >= 0 And OutputDeviceID < OutPutListCount
    CallFunction(*BassDLL, "BASS_SetDevice", (OutputDeviceID & $FF) + 1)
    If CallFunction(*BassDLL, "BASS_Init", (OutputDeviceID & $FF) + 1, 44001, 0, hWnd, 0)
      GetFuncs()
      xSystem = 1
      ProcedureReturn 1
      EndIf
    EndIf
  EndProcedure


CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
  Procedure.l DriveIDfromLetter(DriveLetter.s)
    Define.l xLong1
    Define.l DriveIDfromLetter
  
    xLong1 = Asc(UCase(Left(DriveLetter, 1))) - 65
    Repeat
      ;Debug *BASS_CD_GetDriveLetter
      ;Debug "For " + Str(DriveIDfromLetter) + ": " + Str(CallFunctionFast(*BASS_CD_GetDriveLetter, DriveIDfromLetter))
      ;Debug "Want: " + Str(xLong1)
      Select CallFunctionFast(*BASS_CD_GetDriveLetter, DriveIDfromLetter)
      ;Select CallFunctionFast(*BASS_CD_GetDriveLetter, @xLong1)
        Case xLong1
          Break
        Case -1
          DriveIDfromLetter = -1
          Break
        Default
          DriveIDfromLetter = DriveIDfromLetter + 1
        EndSelect
      ForEver
    ProcedureReturn DriveIDfromLetter
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_ReadTags
  Procedure.f GetQualityMultiByFilename(Filename.s)
    Define Result.f
  
    Select LCase(GetExtensionPart(Filename))
      Case "wav"
        Result = 0.1
      Case "flac"
        Result = 0.2
      Default
        Result = 1
      EndSelect
    ProcedureReturn Result
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_LoadSongA
  ProcedureDLL.l ctSSLayer_LoadSongA(mode.l, *Filename, Flags.l) ;, FullMode.s,, TrackID.l)
  CompilerElse
  Procedure.l ctSSLayer_LoadSongA(mode.l, *Filename, Flags.l) ;, FullMode.s,, TrackID.l)
  CompilerEndIf

  Define.l xLong1
  Define.l FlagsNew
  Define *SongPointer.tSong = AllocateMemory(SizeOf(tSong))
  Define.s FilenameAnsi = PeekS(*Filename)

  If *SongPointer
    Select Mode
      Case #ctSSLayer_MusicTypeStream
        Select LCase(GetExtensionPart(FileNameAnsi))
          Case "mpc"
            *SongPointer\Pointer = CallFunctionFast(*BASS_MPC_StreamCreateFile, 0, *FileName, 0, 0, 0)
            *SongPointer\Mode = $11
          Case "wma"
            *SongPointer\Pointer = CallFunctionFast(*BASS_WMA_StreamCreateFile, 0, *FileName, 0, 0, 0)
            *SongPointer\Mode = $12
          Case "flac"
            *SongPointer\Pointer = CallFunctionFast(*BASS_FLAC_StreamCreateFile, 0, *FileName, 0, 0, 0)
            *SongPointer\Mode = $13
          Case "aac"
            *SongPointer\Pointer = CallFunctionFast(*BASS_AAC_StreamCreateFile, 0, *FileName, 0, 0, $20000)
            *SongPointer\Mode = $14
          ;Case "mp4"
          ;  *SongPointer\Pointer = CallFunctionFast(*BASS_MP4_StreamCreateFile, 0, *FileName, 0, 0, $20000)
          ;  *SongPointer\Mode = $15
          Case "ape"
            *SongPointer\Pointer = CallFunctionFast(*BASS_APE_StreamCreateFile, 0, *FileName, 0, 0, 0)
            *SongPointer\Mode = $16
          Case "ac3"
            *SongPointer\Pointer = CallFunctionFast(*BASS_AC3_StreamCreateFile, 0, *FileName, 0, 0, $200)
            *SongPointer\Mode = $17
          Default
            If (Flags & 1)
              FlagsNew = $20000
              EndIf
            *SongPointer\Pointer = CallFunctionFast(*BASS_StreamCreateFile, 0, *FileName, 0, 0, FlagsNew)
            *SongPointer\Mode = $10
          EndSelect
      Case #ctSSLayer_MusicTypeTracker
        *SongPointer\Pointer = CallFunctionFast(*BASS_MusicLoad, 0, *FileName, 0, 0, $28000, 0)
        *SongPointer\Mode = 1
  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      Case #ctSSLayer_MusicTypeCDAudio
        ;Debug "x"
        *SongPointer\Pointer = CallFunctionFast(*BASS_CD_StreamCreate, DriveIDfromLetter(FileNameAnsi), Val(GetTrackNumber(FileNameAnsi)) - 1, 0)
        ;Debug *SongPointer\Pointer
        ;Debug "DriveID: " + Str(DriveIDfromLetter(FileNameAnsi))
        ;Debug "Track: " + Str(Val(GetTrackNumber(FileNameAnsi)) - 1)
        *SongPointer\Mode = 5
  CompilerEndIf
      EndSelect
    
    If *SongPointer\Pointer
      xLong1 = CreateFile_(FileNameAnsi, $80000000, 1, #Null, 3, $20, 0)
      If xLong1
        *SongPointer\FileSize = GetFileSize_(xLong1, #Null)
        CloseHandle_(xLong1)
        EndIf
      *SongPointer\Size = (BASS_ChannelBytes2Seconds(*SongPointer\Pointer, BASS_ChannelGetLength(*SongPointer\Pointer))) * 1000
      CompilerIf #ctSSLayer_CompiledFeature_ReadTags
        *SongPointer\Format_QualityMulti = GetQualityMultiByFilename(FileNameAnsi)
        CompilerEndIf
      xLong1 = Len(FileNameAnsi)
      ProcedureReturn *SongPointer
      Else
      ;*SongPointer\Mode = 0
      FreeMemory(*SongPointer)
      EndIf
    EndIf
CompilerIf #ctSSLayer_CompiledFeature_LoadSongA ; for PB IDE folding feature
  EndProcedure                                  ; for PB IDE folding feature
CompilerElse                                    ; for PB IDE folding feature
  EndProcedure                                  ; for PB IDE folding feature
CompilerEndIf                                   ; for PB IDE folding feature

CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
  ProcedureDLL.l ctSSLayer_LoadSongW(mode.l, *Filename, CheckAccurate.l) ;, FullMode.s,, TrackID.l)
    Define.s xChar1 = PeekS(*Filename, -1, #PB_Unicode)
    ProcedureReturn ctSSLayer_LoadSongA(mode, @xChar1, CheckAccurate)
    EndProcedure
  CompilerEndIf

ProcedureDLL.l ctSSLayer_LoadSongFinished(*SongPointer.tSong)
  ProcedureReturn 1
  EndProcedure

ProcedureDLL ctSSLayer_LoadSongAbort(*SongPointer.tSong)
  Select *SongPointer\Mode
    Case 0, 5 ; none / cd
    Case 1 ; tracker
      CallFunctionFast(*BASS_MusicFree, *SongPointer\Pointer)
    Default
      CallFunctionFast(*BASS_StreamFree, *SongPointer\Pointer)
    EndSelect
  ;*SongPointer\Mode = 0
  FreeMemory(*SongPointer)
  EndProcedure

ProcedureDLL.l ctSSLayer_LoadSongPlay(*SongPointer.tSong, Volume.l, LoopSong.l, Panning.l, Paused.l)
  ;*SongPointer\CurVolume = Volume
  If *SongPointer\Mode
    If Paused
      BASS_ChannelSetAttributes(*SongPointer\Pointer, -1, 0, -101)
      Else
      BASS_ChannelSetAttributes(*SongPointer\Pointer, -1, (Volume / 2.55), -101)
      EndIf
    If *SongPointer\Mode = 1
      CallFunctionFast(*BASS_MusicSetAttribute, *SongPointer\Pointer, 1, Panning) ; * 100)
      EndIf
    CallFunctionFast(*BASS_ChannelPlay, *SongPointer\Pointer, 0)
    If Paused
      CallFunctionFast(*BASS_ChannelPause, *SongPointer\Pointer)
      Else
      *SongPointer\ShouldPlay = 1
      EndIf
    If *SongPointer\Mode = 1
      CallFunctionFast(*BASS_MusicSetAttribute, *SongPointer\Pointer, 1, Panning) ; * 100)
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      ElseIf *SongPointer\Mode = 5
      IsCDing = 1
CompilerEndIf
      EndIf
    ProcedureReturn 1
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased = 2
  ProcedureDLL.l ctSSLayer_MusicGetPattern(*SongPointer)
    EndProcedure
  
  ProcedureDLL.l ctSSLayer_MusicGetPatterns(*SongPointer)
    EndProcedure
  
  ProcedureDLL.l ctSSLayer_MusicHasFinished(*SongPointer.tSong)
    If *SongPointer\Mode = 1
      Select CallFunctionFast(*BASS_ChannelIsActive, *SongPointer\Pointer)
        Case #BASS_ACTIVE_STALLED, #BASS_ACTIVE_STOPPED
          ProcedureReturn 1
        EndSelect
      EndIf
    EndProcedure
  
  ProcedureDLL.l ctSSLayer_MusicTime(*SongPointer)
    EndProcedure
  CompilerEndIf

Procedure EnumerateDrv(MainHWnd.l)
  Define.l xLong1

  If CallFunction(*BassDLL, "BASS_Init", 0, 44001, 0, MainHWnd, 0)
    Repeat
      xLong1 = CallFunction(*BassDLL, "BASS_GetDeviceDescription", OutPutListCount + 1)
      If xLong1
        ;Debug "Enum: " + PeekS(xLong1)
        OutPutList(OutPutListCount) = PeekS(xLong1)
        OutPutListCount + 1
        If OutPutListCount = #OutPutListMax
          Break
          EndIf
        Else
        Break
        EndIf
      ForEver
    CallFunction(*BassDLL, "BASS_Free")
    EndIf
  EndProcedure

ProcedureDLL.l ctSSLayer_PreInit(MainHWnd.l)
  Define.l xLong1
  
  OutPutListCount = 0
  *BassDLL = OpenLibrary(#PB_Any, "bass.dll")
  If *BassDLL

    VersionIDEx = GetFileVersionEx("bass.dll")
    VersionID = (VersionIDEx & $FFFF) + ((VersionIDEx & $FFFF0000) >> 16) * 10000
  
    xSysPath = GetWinSysPath()

    If TestForDLL(xSysPath + "dsound.dll", $40003) = 0
      xNoDirectX = 1
      EndIf
    GetPreFuncs()
    If ctSSLayer_CanUseItem($20) < 20
      EnumerateDrv(MainHWnd)
      ProcedureReturn OutPutListCount
      EndIf
    Else
    VersionID = -1
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_ReadTags
CompilerIf #ctSSLayer_CompiledFeature_ReadTagsA
  ProcedureDLL.l ctSSLayer_ReadSongInfoA(*SongPointer.tSong, *xSongInfo.QPSongInfoStruct)
CompilerElse
  Procedure.l ctSSLayer_ReadSongInfoA(*SongPointer.tSong, *xSongInfo.QPSongInfoStruct)
CompilerEndIf
    ;Define.l xLong1
    ;Define.l xLong2
    Define.QPSongInfoStruct xType1
    Define.BASS_CHANNELINFO xType2
    
    ;Global strTitle.s
    ;Global strArtist.s
    ;Global strAlbum.s
  
    ;ProcedureReturn 1
    ;MessageRequester("1", "2")
    If CallFunctionFast(*BASS_ChannelGetInfo, *SongPointer\Pointer, @xType2)
  ;      ProcedureReturn 1
      ;xLong1 = CreateFile_(FileName, $80000000, 1, #Null, 3, $20, 0)
      ;MessageRequester("1", "3")
      ;If xLong1
      ;  xLong2 = GetFileSize_(xLong1, #Null)
      ;  CloseHandle_(xLong1)
      If *SongPointer\FileSize
        ;MessageRequester("1", "3")
        xType1\Format_BitRate = *SongPointer\FileSize / *SongPointer\Size * 8000
        xType1\Format_Channels = xType2\chans
        xType1\Format_Frequency = xType2\freq
        xType1\FormatOK = 1
        PokeF(@xType1\Format_QualityMulti, *SongPointer\Format_QualityMulti)
        ;MessageRequester("1", "7")
        RtlMoveMemory_(*xSongInfo, @xType1, SizeOf(xType1))
        EndIf
      EndIf
    ;MessageRequester("1", "8")
    ;*xSongInfo\Tag_Title = @strTitle
    ;*xSongInfo\Tag_Artist = @strArtist
    ;*xSongInfo\Tag_Album = @strAlbum
    ProcedureReturn 1
CompilerIf #ctSSLayer_CompiledFeature_ReadTagsA
    EndProcedure
CompilerElse
    EndProcedure
CompilerEndIf

  CompilerIf #ctSSLayer_CompiledFeature_ReadTagsW
    ProcedureDLL.l ctSSLayer_ReadSongInfoW(*SongPointer, *xSongInfo)
      ; pure redirect because there are not strings yet (strptr = 0)
      ProcedureReturn ctSSLayer_ReadSongInfoA(*SongPointer, *xSongInfo)
      EndProcedure
    CompilerEndIf
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_RefreshDeviceList
  ProcedureDLL.l ctSSLayer_RefreshDeviceList(hWnd.l)
    ProcedureReturn OutPutListCount
    EndProcedure
  CompilerEndIf

ProcedureDLL.l ctSSLayer_SeekSong(*SongPointer.tSong, SeekPosition.l)
  If *SongPointer\Mode
    If SeekPosition > -1 And *SongPointer\Size > 0 And (SeekPosition < *SongPointer\Size Or *SongPointer\Mode = 1 And SeekPosition < *SongPointer\ExtraA)
      ;PrintN("Seeking...")
      ;PrintN("  " + Str(*SongPointer\Pointer))
      ;PrintN("  " + Str(SeekPosition / 1000))
      ;PrintN("  " + Str(BASS_ChannelSeconds2Bytes(*SongPointer\Pointer, SeekPosition / 1000)))
      BASS_ChannelSetPosition(*SongPointer\Pointer, BASS_ChannelSeconds2Bytes(*SongPointer\Pointer, SeekPosition / 1000))
      ;PrintN("  done")
      If *SongPointer\ShouldPlay
        ;PrintN("  TestDoesPlay")
        Select CallFunctionFast(*BASS_ChannelIsActive, *SongPointer\Pointer)
          Case #BASS_ACTIVE_STALLED, #BASS_ACTIVE_STOPPED
            ;PrintN("  MustPlay")
            CallFunctionFast(*BASS_ChannelPlay, *SongPointer\Pointer, 0)
          EndSelect
        ;PrintN("  k")
        EndIf
      ProcedureReturn 1
      EndIf
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
  ProcedureDLL.l ctSSLayer_SetEndCallback(HWnd.l, Message.l, wParam.l)
    EndProcedure
  CompilerEndIf

ProcedureDLL ctSSLayer_SetPause(*SongPointer.tSong, Pause.l)
;  If ResumeVolume = -1
;    ResumeVolume = *SongPointer\CurVolume
;    Else
;    *SongPointer\CurVolume = ResumeVolume
;    EndIf

  If *SongPointer\Mode
    If Pause
      CallFunctionFast(*BASS_ChannelPause, *SongPointer\Pointer)
      Else
      CallFunctionFast(*BASS_ChannelPlay, *SongPointer\Pointer, #False)
      EndIf
    *SongPointer\ShouldPlay = Pause
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_Spectrum
  ProcedureDLL ctSSLayer_SetSpectrum(Status.l)
    EndProcedure
  CompilerEndIf

ProcedureDLL ctSSLayer_SetVolume(*SongPointer.tSong, Volume.l)
  ;*SongPointer\CurVolume = Volume
  If *SongPointer\Mode
    BASS_ChannelSetAttributes(*SongPointer\Pointer, 0, (Volume / 2.55), 0)
    EndIf
  EndProcedure

ProcedureDLL.l ctSSLayer_SongLength(*SongPointer.tSong)
  If *SongPointer\Mode
    ProcedureReturn *SongPointer\Size
    EndIf
  EndProcedure

ProcedureDLL ctSSLayer_UnloadSong(*SongPointer.tSong) ;, RestoreVolume.l)
  Select *SongPointer\Mode
    Case 0 ;, 5
    Case 1
      CallFunctionFast(*BASS_MusicFree, *SongPointer\Pointer)
    Default
      CallFunctionFast(*BASS_StreamFree, *SongPointer\Pointer)
      CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
        If *SongPointer\Mode = 5
          IsCDing = 0
          EndIf
        CompilerEndIf
    EndSelect
  ;*SongPointer\Mode = 0
  FreeMemory(*SongPointer)
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
  ProcedureDLL ctSSLayer_UpdateCDDA(UseCDDA.l, UseJitterCorrection.l)
    ;xUseCDDA = (UseCDDA And ctSSLayer_CanUseItem(0))
    ;xUseJitter = UseJitterCorrection And ctSSLayer_CanUseItem(1)
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased = 2
  ProcedureDLL ctSSLayer_UpdateLooping(*SongPointer, LoopSong.l)
    EndProcedure
  CompilerEndIf  

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
  ProcedureDLL ctSSLayer_UpdatePanning(*SongPointer.tSong, Panning.l)
    If *SongPointer\Mode
      CallFunctionFast(*BASS_MusicSetAttribute, *SongPointer\Pointer, 1, Panning) ; * 100)
      EndIf
    EndProcedure
  CompilerEndIf

ProcedureDLL.l ctSSLayer_Version(OptionalLayerVersionID.l)
  Select OptionalLayerVersionID
    Case 0, $10000682, $10000690
      ProcedureReturn $10000690
    EndSelect
  EndProcedure

CompilerIf 0
AttachProcess(0)
If ctSSLayer_Version($10000640)
  Debug "1"
  If ctsslayer_preinit(-1, 0)
    ;Debug ctsslayer_canuseitem($20)
    ;Debug ctsslayer_canuseitem($21)
    Debug PeekS(ctsslayer_getinfostringa($1)) + " " + PeekS(ctsslayer_getinfostringa($30))
    ;Debug VersionID
    If ctsslayer_init(0, 0, 0, 0)
      Debug "inited"
      Define.l xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeCDAudio, @"r:\track01.cda", 1)
      If xLong1
        Debug "loadok"
        Delay(2000)
        Debug ctsslayer_loadsongplay(xLong1, 255, 0, 80, 0)
        ;Repeat
        ;  Delay(100)
        ;  ForEver
        Delay(2000)
        ctSSLayer_SeekSong(xLong1, 50)
        Delay(5000)
        EndIf
      EndIf
    EndIf
  EndIf

DetachProcess(0)
CompilerEndIf

XIncludeFile "ctSSLayer_Common02.pb"

; IDE Options = PureBasic 4.51 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 345
; FirstLine = 338
; Folding = ------------------
; Executable = C:\Q05006\SYSTEM\ctsslay.dll
; DisableDebugger
; IncludeVersionInfo
; VersionField0 = 1,0,0,5600
; VersionField1 = 1,0,0,5600
; VersionField2 = ctuser
; VersionField3 = ctSSLayer
; VersionField4 = 1.00 beta 56
; VersionField5 = 1.00 beta 56 (2006.09.23)
; VersionField6 = BASS sound system layer
; VersionField7 = ctSSLay
; VersionField8 = ctSSLay.dll
; VersionField9 = Copyright 2002-2006 by Jan Vorel; Published under the GNU General Public License
; VersionField16 = VFT_DLL
; VersionField18 = Comments
; VersionField21 = Published under the GNU General Public License; homepage: http://www.ctuser.net; Uses BASS soundsystem: http://www.un4seen.com; compressed with upx: http://upx.sourceforge.net