EnableExplicit

  #ctSSLayer_MusicTypeNone = 0
  #ctSSLayer_MusicTypeTracker = 1
  #ctSSLayer_MusicTypeStream = 2
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
  #ctSSLayer_MusicTypeCDAudio = 3
  CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
  #ctSSLayer_MusicTypeInetStream = 4
  CompilerEndIf

;CompilerIf #ctSSLayer_CompiledFeature_Spectrum
;  #ctSSLayer_SpectrumArrayCount = 32
;  CompilerEndIf



CompilerIf #ctSSLayer_CompiledFeature_Spectrum
  Procedure.f MaxF(xVar1.f, xVar2.f)
    If xVar1 > xVar2
      xVar2 = xVar1
      EndIf
    ProcedureReturn xVar2
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_NoNeedUnicodeConversion_AtoW = 0
  Procedure MakeUnicode()
    Define.l xLong1
    Define.l xLong2
    
    xLong2 = Len(InfoString)
    xLong1 = ReAllocateMemory(InfoStringW, xLong2 * 2 + 2)
    If xLong1
      InfoStringW = xLong1
      PokeS(InfoStringW, InfoString, xLong2, #PB_Unicode)
      ElseIf InfoStringW
      FreeMemory(InfoStringW)
      InfoStringW = 0
      EndIf
    EndProcedure
  CompilerEndIf

;Procedure MakeAnsi()
;  If InfoStringW
;    InfoString = PeekS(InfoStringW, 4, #PB_Unicode)
;    Else
;    InfoString = ""
;    EndIf
;  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
  Procedure.s GetTrackNumber(FileName.s)
    Define.l xLong1
    Define.l xLong2
    Define.s GetTrackNumber
    
    xLong1 = Len(FileName) - 4
    While xLong2 < xLong1
      xLong2 = xLong2 + 1
      If Not FindString("0123456789", Mid(FileName, xLong2, 1), 1) = 0
        FileName = Mid(FileName, xLong2, Len(FileName) + 1 - xLong2)
        xLong1 = xLong1 - xLong2 + 2
        xLong2 = 1
        While xLong2 < xLong1
          xLong2 = xLong2 + 1
          If FindString("0123456789", Mid(FileName, xLong2, 1), 1) = 0
            Break
            EndIf
          Wend
        If Not xLong2 = 1
          GetTrackNumber = Left(FileName, xLong2 - 1)
          EndIf
        EndIf
      Wend
    ProcedureReturn GetTrackNumber
    EndProcedure
  CompilerEndIf

Procedure.s GetWinSysPath()
  #xMaxPathLen = 256
  Define.l xLong1
  Define.s GetWinSysPath

  GetWinSysPath = Space(#xMaxPathLen)
  xLong1 = GetSystemDirectory_(@GetWinSysPath, #xMaxPathLen)
  ;xLong1 = FindString(GetWinSysPath, vbNullChar, 1) - 1
  If Len(GetWinSysPath) = #xMaxPathLen
    GetWinSysPath = ""
    Else
    GetWinSysPath = Left(GetWinSysPath, xLong1)
    If Not Right(GetWinSysPath, 1) = "\"
      GetWinSysPath = GetWinSysPath + "\"
      EndIf
    EndIf
  ProcedureReturn GetWinSysPath
  EndProcedure

Procedure.l GetFileVersionEx(FileName.s) ;, *Revision)
  Define.VS_FIXEDFILEINFO *xType1
  Define.l xLong1
  Define.l xLong2
  Define *Mem
  ;xChar1.s
  
  xLong1 = GetFileVersionInfoSize_(FileName, @xLong2)
  If xLong1
    *Mem = AllocateMemory(xLong1)
    If *Mem
      ;xChar1 = Space(xLong1)
      ;Debug "oka"
      If GetFileVersionInfo_(FileName, xLong2, xLong1, *Mem)
        ;Debug *Mem
        ;Debug xLong2
        ;Goto lbl1
        ;Debug "ok0"
        If VerQueryValue_(*Mem, "\", @xLong1, @xLong2)
          ;Debug "ok1"
          If xLong2 = SizeOf(VS_FIXEDFILEINFO)
            *xType1 = xLong1 ; xLongxType1\dwFileVersionLS
            ;Debug "ok2"
            ;CopyMemory(xLong1, @xType1, xLong2)
            ;If xType1\dwFileVersionMS ; + xType1\dwFileVersionLS
              ;If *Revision
              ;  PokeL(*Revision, xType1\dwFileVersionLS)
              ;  EndIf
              FreeMemory(*Mem)
              ProcedureReturn *xType1\dwFileVersionMS
            ;  EndIf
            EndIf
          EndIf
        EndIf
      ;lbl1:
      FreeMemory(*Mem)
      EndIf
    EndIf
  EndProcedure

Procedure.l TestForDll(Filename.s, MinFileVersion.l, MaxFileVersion.l = $7fffffff)
  Define.l TestForDll

  TestForDll = GetFileVersionEx(Filename)
  ;If TestForDll
  ;Debug "  VerIs: " + Hex(TestForDll) + " " + Str(TestForDll)
  If Not (TestForDll < MinFileVersion Or TestForDll > MaxFileVersion)
    TestForDll = OpenLibrary(#PB_Any, Filename)
    If TestForDll
      CloseLibrary(TestForDll)
      ProcedureReturn 1
      EndIf
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_ReadTags
  Procedure.s TrimA(xString.s)
    Define.l StartPos = 1
    Define.l CharCount = Len(xString)
    Define.l xLong1

    While CharCount
      If Asc(Mid(xString, CharCount, 1)) < 33
        CharCount - 1
        Else
        Break
        EndIf
      Wend

    While CharCount
      If Asc(Mid(xString, StartPos, 1)) < 33
        CharCount - 1
        StartPos + 1
        Else
        Break
        EndIf
      Wend
    
    If CharCount
      For xLong1 = StartPos To StartPos + CharCount - 1
        If Asc(Mid(xString, xLong1, 1)) < 32
          PokeB(@xString + xLong1 - 1, 32)
          EndIf
        Next
      ProcedureReturn Mid(xString, StartPos, CharCount)
      EndIf
    EndProcedure

  Procedure TrimW(*ptrStartPos, *ptrCharCountWONC) ;characters (not bytes!) without nullchar(s)
    ; will once trim / fix le/be  
    ; 32 - 00 if no BigEndian, ... no swaping,,,?
    Define.l StartPos
    Define.l CharCount
    Define.l xLong1
    ;Define.l CharCountOld
  
    StartPos = PeekL(*ptrStartPos)
    CharCount = PeekL(*ptrCharCountWONC)
    ;CharCountOld = CharCount
    
  ;  ProcedureReturn
    
  ;  If CharCount
      Repeat
        ;Break
        If PeekW(StartPos) < 33
          StartPos + 2
          CharCount - 1
          If CharCount = 0
            Goto TrimW_Lbl1
            EndIf
          Else
          Break
          EndIf
        ForEver
      Repeat
        ;Break
        If PeekW(StartPos + CharCount * 2 - 2) < 33
          CharCount - 1
          If CharCount = 0
            Goto TrimW_Lbl1
            EndIf
          Else
          Break
          EndIf
        ForEver
      PokeL(*ptrStartPos, StartPos)
      For xLong1 = StartPos To StartPos + CharCount * 2 - 2 Step 2
        If PeekW(xLong1) < 32
          PokeL(xLong1, 32)
          EndIf
        Next
  TrimW_Lbl1:
      PokeL(*ptrCharCountWONC, CharCount)
      PokeW(StartPos + CharCount * 2, 0)
  ;    EndIf
    EndProcedure
  CompilerEndIf



; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 5
; FirstLine = 3
; Folding = --
; DisableDebugger